//David Cheung
//U49303740
//SC447
//Lab 3
//10/14/98
//Elevator simulation


// building.cpp: implementation of the building class.
//
//////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <stdlib.h>
#include <windows.h>
#include "people.h"
#include "building.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

building::building()
{

}

building::~building()
{

}

void building::start()
{

	cout << "******" << endl;
	int k;

	while(1)
	{
		makepeople();
		print();
		for(k=0;k<4;k++)
		{
		el[k].run(fl[el[k].crflr]);
		if(el[k].sleep && (el[k].numppl == 0))
		{
			wakeelevator(el[k]);
		}
		else
			el[k].sleep=false;

		Sleep(500);
		}

	}


}

int building::closestfloor(int crfloor)
{
	// this function searches the closest floor
	// that has people on it. Compares with
	// the current floor of the elevator.
	int i=0;
	int j=0;
	int floor=0;
	bool gotup;
	bool gotdn;
	gotup=false;
	gotdn=false;
	bool ansrequp,ansreqdn;
	ansrequp=false;
	ansreqdn=false;


	//search up;
	for(i=crfloor;i<=9;i++)
	{
		if(( fl[i].numdnppl >0) && fl[i].reqdn )
		{	
			gotup=true;
			ansreqdn=true;
		}
		else if( (fl[i].numupppl > 0 ) && fl[i].requp )
		{
			ansrequp=true;
			gotup=true;
		}
		if (gotup) break;
	}
	// search down:
	for(j=crfloor;j>=0;j--)
	{
		if( (fl[j].numdnppl > 0) && fl[j].reqdn )
		{
			gotdn=true;
			ansreqdn=true;
		}
		else if ((fl[j].numupppl > 0) && fl[j].requp)
		{

			ansrequp=true;
			gotdn=true;
		}
		if(gotdn) break;
	}
	if(gotup && gotdn)
	{
		if(i-crfloor > crfloor - j)
			floor=j;
		else
			floor=i;
	}
	else
	{
		if(!gotdn && gotup)
			floor=i;
		else
		{
			if(!gotup && gotdn)
				floor=j;
		}
	}
	if (!gotdn && !gotup)
		floor=crfloor;

	if( !(gotdn && gotup))
	{
		if(ansrequp)
			fl[floor].requp=false;
		else
			fl[floor].reqdn=false;
	}

	return floor;

}

void building::print()
{
	int k=0;

	cout<< "B \t1 \t2 \t3 \t4 \t5 \t6 \t7 \t8 \t9"<<endl;
	for(k=0;k<9;k++)
		cout<< "up:dn \t";
	cout << "up:dn" << endl;

	for(k=0;k<9;k++)
		cout<< "ru:rd \t";
	cout << "ru:rd" << endl;
	
	for(k=0;k<10;k++)
		cout<< fl[k].numupppl << ":" << fl[k].numdnppl << "\t";

	for(k=0;k<10;k++)
		cout<< fl[k].requp << ":" << fl[k].reqdn << "\t";
	cout << endl;

	cout << endl;
		
	cout << "el#  \tcf:  \tdf:  \tdir:  \tnum:   \tslp:  "<<endl;   
	for(k=0;k<4;k++)
	{
		cout << k;
		cout << "\t"<<el[k].crflr;
		cout << "\t"<<el[k].destflr;
		cout << "\t "<<el[k].direction;
		cout << "\t" << el[k].numppl;
		cout << "\t"<<el[k].sleep;
		cout << endl;;
	}
		

	cout << endl;

}

int building::farthestfloor(int crfloor)
{
	//this is a slight modification of closestfloor

	// this function searches the closest floor
	// that has people on it. Compares with
	// the current floor of the elevator.
	int i=0;
	int j=0;
	int floor=0;
	bool gotup;
	bool gotdn;
	bool ansrequp,ansreqdn;
	gotup=false;
	gotdn=false;
	ansrequp=false;
	ansreqdn=false;
	//search up;
	for(i=9;i>crfloor;i--)
	{
		if(( fl[i].numdnppl >0) && fl[i].reqdn )
		{	
			gotup=true;
			ansreqdn=true;
		}
		else if( (fl[i].numupppl > 0 ) && fl[i].requp )
		{
			ansrequp=true;
			gotup=true;
		}
		if (gotup) break;
	}
	// search down:
	for(j=0;j<crfloor;j++)
	{
		if( (fl[j].numdnppl > 0) && fl[j].reqdn )
		{
			gotdn=true;
			ansreqdn=true;
		}
		else if ((fl[j].numupppl > 0) && fl[j].requp)
		{

			ansrequp=true;
			gotdn=true;
		}
		if(gotdn) break;
	}
	if(gotup && gotdn)
	{
		if(i-crfloor >= crfloor - j)
			floor=i;
		else
			floor=j;
	}
	else
	{
		if(!gotdn && gotup)
			floor=i;
		else
		{
			if(!gotup && gotdn)
				floor=j;
		}
	}
	if (!gotdn && !gotup)
		floor=crfloor;
//	cout << "wake up: " << i;
//	cout << " wake down: "<< j << endl;
//	cout << "gotup: "<< gotup;
//	cout << " gotdn: "<< gotdn<<endl;
	if( !(gotdn && gotup))
	{
		if(ansrequp)
			fl[floor].requp=false;
		else
			fl[floor].reqdn=false;
	}

	return floor;

}

void building::wakeelevator(elevator &el)
{
	if(el.sleep)
	{
		if( (el.eleid==0) || (el.eleid==2))
		{
			el.destflr=closestfloor(el.crflr);

		}
		else
		{
			el.destflr=farthestfloor(el.crflr);
		}
	}
	if(el.destflr != el.crflr)
		el.sleep=false;

}

void building::makepeople()
{


	int cfl=0;
	int dfl=0;
	int odds=40;
	dfl=rand();
	cfl=rand() % 10; //nth floor person go to.
	if(dfl % odds <=10)
		fl[cfl].createpeople();
		
}
