//David Cheung
//U49303740
//SC447
//Lab 3
//10/14/98
//Elevator simulation


// elevator.cpp: implementation of the elevator class.
//
//////////////////////////////////////////////////////////////////////

#include <stdlib.h>
#include <iostream.h>
#include "elevator.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

elevator::elevator()
{

	crflr=0;
	destflr=0;
	direction=0;
	numppl=0;
	eleid=ident;
	ident++;
	sleep=true;
	int i;
	for(i=0;i<15;i++)
		ppl[i]=0;
}

elevator::~elevator()
{

}

int elevator::ident=0;
void elevator::run(floor &fl)
{
	if (crflr==destflr)
	{
			kickppl();
		direction =0;
		getdestflr();
		  // this should make a little pause between
					  // stops.
		if(crflr==destflr)
			sleep=true;
		// if the destflr is still = crflr, there's
		// no one in elevator and its waiting for
		// orders gets awaked again only by 
		// the building.
	}
	else
	{
		if (crflr>destflr)
		{
			direction = -1;
		}
		if(crflr < destflr)
		{
			direction = 1;
		}
	}

	if(floor_panel.floors[crflr])
	{
		if(numppl > 0)
		{
			kickppl();  //if anyone reached destination, kick them out!
		}
	}

	if(fl.numdnppl && (direction==-1))
		getdnppl(fl);
	if(fl.numupppl && (direction==1))
		getupppl(fl);
	if(direction == 0)
	{
		getdnppl(fl);
		getupppl(fl);
	}

		elevatormove();

}

void elevator::elevatormove()
{
	crflr+=direction;
	//cout << "crflr is "<<crflr << endl;

}

void elevator::kickppl(void)
{
	// the kick ppl looks at the
	// current floor, and determines
	// if any people  in the elevator
	// is suppose to come out. It should
	// decrement the number of people in the
	// elevator as well. also, this is executed
	// only then the elevator stops, ie, when
	// the elevator's direction is zero. this way,
	// kickppl doesn't need to check if the elevator
	// is moving.

	int i,j,num,tmp;
	i=0;
	j=0;
	tmp=0;
	  // okay, ppl itself is the "base" of link list.
	num=0;
	if(numppl > 0)
	{
		for(i=0;i<numppl;i++)
		{
			if(ppl[i]==crflr)
			{
				floor_panel.floors[ppl[i]]=0; //deselects from floor panel...
				cout << "1 person got out of elevator# ";
				cout <<eleid<< " on floor ";
				cout << ppl[i] << endl;
				
				for(j=i;j<=(numppl-1);j++)
				{
					ppl[j]=0;
					tmp=ppl[j];
					ppl[j]=ppl[j+1];
					ppl[j+1]=tmp;
				}
				// reshuffles the array.
				i=-1; // this -1 is needed because i gets
					  // bumped to 1 at the end of the loop
					  // that's why the numppl > 0 is needed.
					  // to prevent the zero bug.
				j=0;
				numppl--; 
				if(numppl < 0)
					numppl=0; //don't want it do go to negative.
						// bug caused because of zeros at 
					    // zero floor
				// starts over for repeated ones.
			}
		}
	}

}


bool elevator::getdestflr()
{
	// getdestflr is suppose to get the destination floors
	// from the panel, and do various calculations before
	// it determines which direction it is going.
	// the bool will return if a destflr has been selec
//	cout << "Getting destflr "<<endl;
	bool gotup;
	gotup=false;
	bool gotdn;
	gotdn=false;
	int i,j;
	j=0;
	i=0;
	for(i=9;i>=crflr;i--)
	{
		if(floor_panel.floors[i]==1)
		{
			gotup=true;
			
		}
		if(gotup) break;
	}
	for(j=0;j<=crflr;j++)
	{
		if(floor_panel.floors[j]==1)
		{
			gotdn=true;
		}
		if(gotdn) break;
	}
	if (gotup && gotdn)
	{
		if(i-crflr > crflr -j)
			destflr=j;
		else
			destflr=i;
	}
	else
	{
		if(!gotdn && gotup)
			destflr=i; //so if no floors going down, then
					   //destfloor is the top one.
		else
		{
			if(!gotup && gotdn)
				destflr=j;
		}
	}
	if ( !gotdn && !gotup)
	{
		destflr=crflr;  //this also means it's sleeping..
//	cout << "destflr is now "<<destflr << endl;
	}
	return (gotdn || gotup);

}

void elevator::createperson(int k)
{
	
	ppl[numppl]=k;
	cout <<"A Person got in elevator ";
	cout <<"requesting "<<k << endl;
	floor_panel.floors[k]=1;
	numppl++;


}

void elevator::getdnppl(floor &fl)
{
	// getdnppl just get the dnpeople from the
	// floor that are linke to the dn list.
	// similifies the getppl function.
	int i;
	i =0;
	bool gotdn=false;
	int numdn;
	fl.reqdn=false;
	numdn=fl.numdnppl;
	if(fl.numdnppl >0)
	{
		for(i=0;i<numdn;i++)
		{
			if(numppl< 15)
				createperson(fl.popdn());
			else
			{
				cout << "elevator# "<<eleid<< " is full!"<<endl;
				break;
			}
		}
	}
	i=0;
	for(i=0;i<=crflr;i++)
	{
		if(floor_panel.floors[i]==1)
		{
			gotdn=true;
		}
		if (gotdn) break;
	}
	if (gotdn) destflr = i;
	

}

void elevator::getupppl(floor &fl)
{
	// getdnppl just get the dnpeople from the
	// floor that are linke to the dn list.
	// similifies the getppl function.
	int i;
	i =0;
	int numup;
	numup=fl.numupppl;
	fl.requp=false;
	if(fl.numupppl >0)
	{
		for(i=0;i<numup;i++)
		{
			if(numppl<15)
				createperson(fl.popup());
			else
			{
				cout << "elevator# "<<eleid<< " is full!"<< endl;
				break;
			}
		}
	}
	i=0;
	bool gotup=false;
	for(i=9;i>crflr;i--)
	{
		if(floor_panel.floors[i]==1)
		{
			gotup=true;
		}
		if (gotup) break;
	}
	if(gotup) destflr=i;

}
